#!/usr/bin/perl -w

# Script baseado no trabalho de Alberto Garcia: http://por2gal.elpiso.org/
# Modificaes feitas por Pablo Gamallo
# Para usar este script desde um shell, deves respeitar a seguinte sintaxe:
# cat  input-file  | port2gal.perl  >  output-file


use strict;
use locale;
use POSIX;

setlocale(LC_CTYPE,"pt_PT");

#print "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n";
#print " TRANSLITERAO AUTOMTICA AO GALEGO DO ILG-RAG (excusas pelos erros)  \n";
#print "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n";
#print "\n";
#print "\n";

my $vogal =  "AEIOUaeiou";
my $consAll = "bBdDtTpPkKvVfFcCzZkKlLrRnNmMpPjJxXsShHqQgG";

my $vogalacentuada =  "\[\]";
my $symbol = "\[\?\!\\\%\&\/\(\)\+\*\"\=\.\,\;\:\]";
my $WChar = "(\[a-zA-Z\])";
my $NaoChar = "(\[ \?\!\\\%\&\/\(\)\+\*\"\'\=\.\,\;\:\])";
my $cons =  "(\[bBdDtTpPkKvVfFcCzZkKlLrRnNmMpPjJxXsShH\])"; ##faltam q e g
my $crecente =  "(ia|ie|io|ue|ua|uo|gua|guo)";
my $decrecente = "(iu|eu|ei|oi|ou|ai|au)";
my $w = "a-zA-Z";

my $GR = "|cr|br|pr|tr|dr|fr|cl|bl|fl";
my $pronComposto = "|no-lo|no-los|no-la|no-las|vo-lo|vo-los|vo-la|vo-las|se-me|se-te|se-che|se-lle|se-lles|se-nos|se-vos";
my $pron = "|me|te|mos|mas|mo|ma|tos|tas|to|ta|che|cho|cha|chas|chos|lo|los|o|os|la|las|a|as|lle|lles|llo|lla|llos|llas|llelo|llela|se|no|vo|nos|vos|nolo|nolos|nola|nolas|volo|volos|vola|volas|seme|sete|seche|selle|selles|senos|sevos";

#my $sufixV "((?:-m|-lh|-t)?)(e?);


 my @l = qw(
([sS])im i
([aA])t ta
([aA])li l
([aA])i 
[aA]car zucre
([bB]isa|[aA])v(s?) b
([bB]isa|[aA])v(s?) boa
Adiciona(r|[aeeou])- Engadi
adiciona(r|[aeeou])- engadi
Adicion(a|[ms]) Engade
adiciona(a|[ms]) engade
apresent- present
Apresent- Present
apresent- present
([aA])rrast([aeeou])- rrastr 
([aA])ssim s
([oO])bjet- bject
((?:[rR]e|[dD]es)?)([aA])to(s?) cto
((?:[rR]e|[dD]es)?)([aA])(o|es) c
((?:[rR]e|[dD]es)?)([aA])cion- ccion
((?:[rR]e|[dD]es)?)([aA])tiv- ctiv
((?:[rR]e|[dD]es)?)([aA])tua(l|i|idade)(s?) ctua
((?:[rR]e|[dD])?)([eE])strutur- structur
((?:[aA]uto|[rR]e|[dD]es)?)([cC])arreg- arg
ecr(s?) pantalla
Ecr(s?) Pantalla
([fF])undo(s?) ondo
frango(s?) polo
Frango(s?) Polo
([hH])omem ome
([oO])ntem nte
j xa
J Xa
cena(s?) escena
Cena(s?) Escena
cenrio(s?) escenrio
Cenrio(s?) Escenrio
([cC])oluna(s?) olumna
([cC])risto(s?) ristin
([cC])rist(s?) risti
([dD]) ea
([dD])ois ous
([dD])vida(s?) beda
([dD])isponv- ispob 
([fF])aculdade(s?) acultade
([fF])ormatao ormato
([fF])ormataes ormatos
item(s?) elemento
Item(s?) Elemento
([tT])u i
((?:d|n|d?aqu)?)ele el
([vV])oc(s?) ostede
([pP])el([oa]s?) ol
((?:sobre)?)tudo(s?) todo
([cC])ampe(s?) ampiona
([cC])ampe(o|es) ampi
((?:[cC]apit|[eE]st|[iI]rm|[aA]lem|[cC]rist)?)o(s?) n
((?:[cC]ora|[dD]oa|[hH]iperliga|[lL]iga)?)o zn
((?:[cC]ora|[dD]oa|[hH]iperliga|[lL]iga)?)es zns
((?:[cC]apit|[iI]rm|[aA]lem|[cC]rist)?)(s?) 
([Ll])has hela
([Ll])hos helo
([nN])em in
([cC])ontedo(s?) ontido
([cC])ontrole(s?) ontrol
([dD])ireit- ereit
fech- pech
Fech- Pech
([gG])uard- ard
([gG])rau(s?)- rao
([hHjJ]o[mv])ens es
hierarquia(s?) xerarquia
Hierarquia(s?) Xerarquia
hierrquico(s?) xerrquico
Hierrquico(s?) Xerrquico
mas pero
Mas Pero
([mM])uulmano(s?) usulmn
([pP])ont(o?|os?|u?)- unt
([pP])ropriedade(s?) ropiedade
([pP])rpri- rpi
pasta cartafol
pastas cartafoles
Pasta Cartafol
Pasta Cartafoles
([pP])aine(l|is) ane
qualquer calquera
quaisquer calquera
Qualquer Calquera
Quaisquer Calquera
sob baixo
Sob Baixo
([tT])rs res
([dD])epois espois
([mM])ais is
([mM])eio dio
([nN])vel ivel
([mM])ui oi
([mM])uit([oa]s?) oit
([pP])essoa([ls]?|is?) ersoa
?(r)([bpdtkvgfczkjxslmnr])o(s?) ao
((?:[cCdDhHmMpPtTvV])?)o(s?) an
([nsNS])o on
([tT])ambm amn
([aA])ssim s
([eEoO])xig([ei)- six
enquanto mentres
Enquanto Mentres
([cC]orr|[eE]l)e([gj])- i
([cC]orri|[eE]li)ge- gi
([cC]orri|[eE]li)g- g
([cC]on|[dD]i)vir([gj])- ver
([cC]onver|[dD]iver)gi- ge
([cC]onver|[dD]iver)g- g
([dD])ormi- urmi
([dD])ormi urmi
([cC]|[eE]nc|[dD]esc)obri- ubri
([cC]|[eE]nc|[dD]esc)obri ubri
([eE]|[sS]obre)stej- ste
?screver scribir
?screver- scribir
?screveu((?:-m|-lh|-t|-ch|-v|-n|-o|-a)?([eoa]?(s?))) scribiu
?screv- scrib
?([vV])iver ivir
?([vV])iver- ivir
?([vV])iveu((?:-m|-lh|-t|-ch|-v|-n|-o|-a)?([eoa]?(s?))) iviu
([cC])onceber oncibir
([cC])onceber- oncibir
([cC])oncebeu((?:-m|-lh|-t|-ch|-v|-n|-o|-a)?([eoa]?(s?))) oncibiu
([cC])onceb- oncib
([rR])ecever ecibir
([rR])ecever- ecibir
([rR])eceveu((?:-m|-lh|-t|-ch|-v|-n|-o|-a)?([eoa]?(s?))) ecibiu
([rR])ecev- ecib
([sS])ou((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) on
([fF])ui((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) un
([fF])oste((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) uches
((?:[aA]|[aA]bs|[eE]s|[cC]on|[dD]e|[mM]an|[oO]b)?)[tT]eve((?:-m|-lh|-t|-ch|-v|-n|-o|-a)?([eoa]?(s?))) tivo
((?:[aA]|[aA]bs|[eE]s|[cC]on|[dD]e|[mM]an|[oO]b)?)[tT]ive((?:-m|-lh|-t|-ch|-v|-n|-o|-a)?([eoa]?(s?))) tivem
([tT])ens((?:-m|-lh|-t|-ch|-v|-n|-o|-a)?([eoa]?(s?))) es
((?:[aA]|[aA]bs|[eE]s|[cC]on|[dD]e|[mM]an|[oO]b)?)tns((?:-m|-lh|-t|-ch|-v|-n|-o|-a)?([eoa]?(s?))) ts
((?:[fF]|[sS]atisf|[lL]iqef|[dD]esf|[cC]ontraf|[rR]aref|[rR]ef))a((?:o|a|as|amos|am|ais)?)((?:-m|-lh|-t|-ch|-v|-n|-o|-a)?([eoa]?(s?))) ag
([fF])azem((?:-m|-lh|-t|-ch|-v|-n|-s|o|-a)?([eoa]?(s?))) an
([fF])azes((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) as
([fF])az-lo(s?) ac-lo
((?:[sS]atisf|[lL]iqef|[dD]esf|[cC]ontraf|[rR]aref|[rR]ef))azem((?:-m|-lh|-t|-ch|-v|-n|-s|o|-a)?([eoa]?(s?))) n
((?:[sS]atisf|[lL]iqef|[dD]esf|[cC]ontraf|[rR]aref|[rR]ef))azes((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) s
((?:[fF]|[sS]atisf|[lL]iqef|[dD]esf|[cC]ontraf|[rR]aref|[rR]ef))aze((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) ai
((?:[fF]|[sS]atisf|[lL]iqef|[dD]esf|[cC]ontraf|[rR]aref|[rR]ef))iz((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) ixen
((?:[fF]|[sS]atisf|[lL]iqef|[dD]esf|[cC]ontraf|[rR]aref|[rR]ef))ez((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) ixo
((?:[fF]|[sS]atisf|[lL]iqef|[dD]esf|[cC]ontraf|[rR]aref|[rR]ef))iz((?:este|emo(s?)|eram|reis|sseis|esse(m|s?)|ssemo(s?)|era(m|s?)|ramo(s?)|er|eres|erdes|erem)?)((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) ix
([hH])((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) ai
([hH])s((?:-m|-lh|-t|-ch|-v|-n|-s)?([eoa]?(s?))) as
([hH])-l([oa](s?)) a-l
((?:[pP]|[aA]nte|[dE]e|[dD]ecom|[iI]dis|[pP]rop|[pP]os|[sS]uperp|[sS]up))s((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) uxo
((?:[pP]|[aA]nte|[dE]e|[dD]ecom|[iI]dis|[pP]rop|[pP]os|[sS]uperp|[sS]up))us((?:este|emos|eram|era(s?)|ramos|esse(s?)|ssemos|essem|er|eres|erdes|erem|reis|sseis)?)((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) ux
((?:[pP]|[aA]nte|[dE]e|[dD]ecom|[iI]dis|[pP]rop|[pP]os|[sS]uperp|[sS]up))ux uxem
([pP])erc((?:o|a|as|amos|am|ais)?)((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) erd
((?:[eE]s|[cC]on|[dD]e|[mM]an|[oO]b)?)[tT]m((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) teen
([vV])m((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) een
((?:[aA]ntev|[pP]rev|[rR]ev|[rR]el|[dD]escr|[eE]ntrev))em((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) n
((?:[aA]ntev|[pP]rev|[rR]ev|[rR]el|[dD]escr|[eE]ntrev))((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) 
((?:[vV]|[lL]|[cC]r))em((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) en
((?:[vV]|[lL]|[cC]r))((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) e
((?:[lL]|[cC]r))ei((?:amos|ais)?)((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) e
((?:[vV]|[lL]|[cC]r))i((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) in
([dD])em eam
((?:[pP]oss|[eE]vol|[cC]onstr|[dD]estr|[rR]econstr|[aAtrib]|[oO]bstr|[cC]oncl|[dD]istrib|[iI]ncl))uis((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) es
((?:[pP]oss|[eE]vol|[cC]onstr|[dD]estr|[rR]econstr|[aAtrib]|[oO]bstr|[cC]oncl|[dD]istrib|[iI]ncl))ui((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) e
((?:[cC]ons|[dD]es|[rR]econs))tris((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) tres
([cC]ons|[dD]es|[rR]econs)tri((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) tre
((?:[cC]ons|[dD]es|[rR]econs))troem((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) trem
((?:[cC]onstr|[dD]estr|[rR]econstr|[aAtribtr]|[oO]bstr|[cC]oncl|[dD]istrib|[iI]ncl))ui((?:mos|ram|ra(s?)|esse(s?)|essem|res|rdes|rem|u|stes)?)((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) u
([vV])ais((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) as
([vV])((?:s)?)((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) aia
((?:[aA]dv|[cC]onv|[iI]nterv|[pP]rov|[dD]esav|[sS]obrev))ais((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) s
((?:[vV]|[aA]dv|[cC]onv|[iI]nterv|[pP]rov|[dD]esav|[sS]obrev))ens((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) s
([vV])eio((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) eu
((?:[vV]|[aA]dv|[cC]onv|[iI]nterv|[pP]rov|[dD]esav|[sS]obrev))i(emos|este(s?)|eram|era(s?)|ramos|esse(s?)|ssemos|essem|er|eres|erdes|erem|reis|sseis)((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) i
([vV])ieste ieches
ansei((?:o|a(s?)|[ea]m|e(s?))?) nsi
ansei((?:o-|a(s?)-|am-)?) nsi
([aA])nsei(amo|[a]v|[a]r|ast)- nsi
([iI])ncendei((?:o|a(s?)|[ea]m|e(s?))?) ncndi
([iI])ncendei((?:o-|a(s?)-|am-)?) ncndi
([iI])ncendei(amo|[a]v|[a]r|ast)- ncendi
odei((?:o|a(s?)|[ea]m|e(s?))?) di
odei((?:o-|a(s?)-|am-)?) di
([oO])dei(amo|[a]v|[a]r|ast)- di
((?:[mM]|[rR]em))edei((?:o|a(s?)|[ea]m|e(s?))?) di
((?:[mM]|[rR]em))edei((?:o-|a(s?)-|am-)?) di
((?:[mM]|[rR]em))edei(amo|[a]v|[a]r|ast)- edi
([pP])ro([i]b)- roh
([pP])de((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) uido
([pP])ude((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) uidem
([pP])osso((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) odo
([pP])oss(a(s?)|mo(s?)|m|ais)((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) oid
([pP])ude- uide
([pP])ud- uid
((?:[pP]|[dD]esp|[iI]mp|[eE]exp||[dD]esimp|[rR]eexp|[mM]|[dD]esm))e(|a(s?)amo(s?)|am|ais)((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) id
((?:[pP]|[dD]esp|[iI]mp|[eE]exp||[dD]esimp|[rR]eexp|[mM]|[dD]esm))eo((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) ido
((?:[pP]|[aA]nte|[dE]e|[dD]ecom|[iI]dis|[pP]rop|[pP]os|[sS]uperp|[sS]up))es((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) os
((?:[pP]|[aA]nte|[dE]e|[dD]ecom|[iI]dis|[pP]rop|[pP]os|[sS]uperp|[sS]up))em((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) oen
((?:[pP]|[aA]nte|[dE]e|[dD]ecom|[iI]dis|[pP]rop|[pP]os|[sS]uperp|[sS]up))e((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) on
((?:[dD]|[bB]end|[cC]ond|[cC]ontrad|[pP]re|[mM]ald|[dD]esd))izei(s?) icide
((?:[dD]|[bB]end|[cC]ond|[cC]ontrad|[pP]re|[mM]ald|[dD]esd))izemos icimos
([dD])izes((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) is
([dD])iz((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) i
([dD])izem((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) in
((?:[bB]end|[cC]ond|[cC]ontrad|[pP]re|[mM]ald|[dD]esd))izes((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) s
((?:[bB]end|[cC]ond|[cC]ontrad|[pP]re|[mM]ald|[dD]esd))iz((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) 
((?:[bB]end|[cC]ond|[cC]ontrad|[pP]re|[mM]ald|[dD]esd))izem((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) n
((?:[dD]|[bB]end|[cC]ond|[cC]ontrad|[pP]re|[mM]ald|[dD]esd))ize- ici
([eE])scut- scoit
([pP])ergunt- regunt
([dD])iss((?:e|este|emo(s?)|eram|reis|sseis|esse(m|s?)|ssemo(s?)|era(m|s?)|ramo(s?))?)((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) ix
([dD])ixe((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) ixo
((?:[qQ]|[rR]eq))uer((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) uere
((?:[qQ]|[rR]eq))uis((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) uixo
((?:[qQ]|[rR]eq))uis((?:este|emo(s?)|eram|reis|sseis|esse(m|s?)|ssemo(s?)|era(m|s?)|ramo(s?)|er|eres|erdes|ermos|erem)?)((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) uix
([tT])raz((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) rae
([tT])raz([e])- ra
([tT])raz([]-)- ra
([tT])razi- ra
([tT])rag((?:o|a|as|amos|am|ais)?)((?:-m|-lh|-t|-ch|-v|-n|-o|-a)?([eoa]?(s?))) rai
([tT])rouxe((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) rouxem
((?:[tT]roux|[pP]ux))este((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) eches
([fF])azem((?:-m|-lh|-t|-ch|-v|-n|-s|o|-a)?([eoa]?(s?))) an
([fF])azes((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) as
((?:[sS]atisf|[lL]iqef|[dD]esf|[cC]ontraf|[rR]aref|[rR]ef))azem((?:-m|-lh|-t|-ch|-v|-n|-s|o|-a)?([eoa]?(s?))) n
((?:[sS]atisf|[lL]iqef|[dD]esf|[cC]ontraf|[rR]aref|[rR]ef))azes((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) s
((?:[fF]|[sS]atisf|[lL]iqef|[dD]esf|[cC]ontraf|[rR]aref|[rR]ef))az((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) ai
((?:[fF]|[sS]atisf|[lL]iqef|[dD]esf|[cC]ontraf|[rR]aref|[rR]ef))iz((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) ixen
((?:[fF]|[sS]atisf|[lL]iqef|[dD]esf|[cC]ontraf|[rR]aref|[rR]ef))ez((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) ixo
((?:[fF]|[sS]atisf|[lL]iqef|[dD]esf|[cC]ontraf|[rR]aref|[rR]ef))iz((?:este|emo(s?)|eram|reis|sseis|esse(m|s?)|ssemo(s?)|era(m|s?)|ramo(s?)|er|eres|erdes|erem|ermos)?)((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) ix
-duz((?:-m|-lh|-t|-ch|-v|-n|-s|-o|-a)?([eoa]?(s?))) uce
((?:[cC]a|[aA]tra|[sS]a|[sS]obresa|[dD]istra))i(s?)((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) e 
((?:[sS]a|[sS]obresa))iu((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) u
((?:[cC]a|[eE]sva|[aA]tra|[dD]istra))iu((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) eu
((?:[sS]a|[sS]obresa))i((?:sse(m|s?)|ra(m|s?)|res|rem|rmos)?)((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) 
((?:[cC]a|[eE]sva|[aA]tra|[dD]istra|[dD]escontra))i((?:res|rem|rmos|rdes)?)((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) e
((?:[cC]a|[eE]sva|[aA]tra|[dD]istra|[dD]escontra))((?:sse(m|s?)|r|ra(m|s?)|res|rem|rmos|rdes))((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) e
((?:[cC]a|[eE]sva|[aA]tra|[dD]istra|[dD]escontra))((?:sse(m|s?)|r|ra(m|s?)|res|rem|ssemos|sseis|ramos|rais))((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) 
((?:[cC]a|[eE]sva|[aA]tra|[dD]istra|[dD]escontra))s((?:sse(m|s?)|ra(m|s?)|res|rem|rmos)?)((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) edes
((?:[dD]|[mM]|[rR]|[rR]em))o((?:sse(m|s?)|ra(m|s?)|res|rem|rmos)?)((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) oio
((?:[dD]|[mM]|[rR]|[rR]em))i((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) oe
((?:[mM]|[rR]))o((?:a(m|s?)|amos|ais))((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) oi
?scer((?:ia(m|s?)|amo(s?)|eis|a(m|s?)|es|em|mos)?)((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) cer
?sc((?:este|ia(m|s?)|amo(s?)|emo(s?)|sseis|esse(m|s?)|ssemo(s?))?)((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) c
([aA])rgi((?:s)?)((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) rge
((?:[aA]d|[aA]dv|[dD]iv|[cC]onf|[dD]if|[iI]nf|[pP]ref|[pP]rof|[rR]ef|[tT]ransf|[cC]omp|[rR]ep|[cC]onc|[dD]isc|[dD]ig|[iI]ng|[sS]ug|[iI]ns|[rR]efl|[mM]|[pP]|[vV]|[iI]nv|[rR]ev|[rR]equ))e((?:re|rte|te|cte|ste|rne|de))((?:s|m)?)((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) i
espe((?:s|m)?)((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) ispe
Espe((?:s|m)?)((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) Ispe
?([lL])ingue(s?) inge
?([lL])inguis- ingis
?([lL])ingus- ings
?([pP])rpr- rp
([mM])uit- oit
([cC])oisa(s?) ousa
([mM])au(s?) alo
([mM])(s?) ala
relatrio(s?) informe
Relatrio(s?) Informe 
([rR])epto(s?) eto 
([tT])abela(s?) boa 
([sS])om(a|ar|a-) um
([uU])tente(s?) surio
qua- ca
Qua- Ca
quo- co
Quo- Co
gest- xesti
Gest- Xesti
questi?- cuesti
Questi?- Cuesti
([fF])requ(n|en)- recu
([gG])ov- ob
([hH]a|[dD]e)v- b
([hH]ou)v- b
([dD])ebolv- evolv
([AaEeOoUu])i([lrnm])([bpdtkvgfczkjxs])- 
?([bBdDtTpPkKvVfFcCzZkKlLrRnNmMjJxXsShH])([aeou])i([lrnm])([bpdtkvgfczkjxs])- 
-([aeou])id([oa])(s?) d
?([AaEeOoIi])u([lrnm])([bpdtkvgfczkjxs])- 
-(u)io cin
-(u)ies cins
-([s])o in
-([s])es ins
-e(s?) n
-es ns
-rro rrn
-ro rn
--o -n
-o n
-(s?) n
-eio(s?) eo
-eia(s?) ea
-eia(m?) ea
-eie(s?) ee
-eie(m?) ee
-imento(s?) emento
-i([oa])(s?) oi
-([aei])ram ron
-(g)em e
-(g)ens es
-([])vel bel
-([])veis beis
-(a|)va((?:s|mo(s?)|m)?) ba
-(a|)va((?:s|mo(s?)|m)?-)- ba
-mos amos
-u eu
-m n
-nh- 
-ss- s
-vr- br
-[ei]ste((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) iches
-aste((?:-m[eoa](s?)|-lh[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?))?) aches
-(g)ens es
?lh- ll
?[z]([ei])? c
?g([ei])? x
?[Z]([ei])? C
?G([ei])? X
([nN])eun ingn
([nN])euma ingunha
((?:[nN]|[dD]|[cC]|[dD]?alg)?)[uU]mh?a(s?) unha
([Ss])o-([\w]+)- om-
([Ss])ou-([\w]*)- om-
([dDvV])o-([\w]+)- am-
-ro-([\w]+)- rm-
-m-n(o|a|as|os) n-
-m-([\w]*)- n-
-i-l(o|a|as|os) -l
-([bBdDtTpPkKvVfFcCzZkKlLrRnNmMjJxXsShH])i(-m[eoa](s?)|-ll[eoa](s?)|-ll[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?)) n
-([gq]u)i(-m[eoa](s?)|-ll[eoa](s?)|-ll[eoa](s?)|-t[eoa](s?)|-ch[eoa](s?)|-vos|-nos|-vo-lo|-no-lo|-se|-o(s?)|-a(s?)) n
ps-- post
);



my $line;
while ($line = <>) {

    chop $line;
    $line = " $line ";
    $line =~ s/ /  /g;
    $line =~ s/\. / \. /g;
    $line =~ s/\.$/ \. /g;
    $line =~ s/\, / \, /g;
    $line =~ s/\; / \; /g;
    $line =~ s/\?/ \? /g;
    $line =~ s/\!/ \! /g;
    $line =~ s/\[/\[ /g;
    $line =~ s/\]/ \] /g;
    $line =~ s/\(/\( /g;
    $line =~ s/\)/ \) /g;
    $line =~ s/\"/ \" /g;
    
    #print STDERR "$line\n";
 


    #trocas da lista de pares irregulares $l:
    my $i;
    for ($i=0;$i<$#l;$i+=2) {
      my ($a,$b) = ($l[$i],$l[$i+1]);
      #print STDERR "$a $b\n";
     #$a =~ s/^([^\?-])/(\\W)$1/;
     #$a =~ s/([^\?-])$/$1(\\W)/;
      $a =~ s/^([^\?-])/$NaoChar$1/;
      $a =~ s/([^\?-])$/$1$NaoChar/;

      #$a =~ s/(^-|-$)/(\\w)/g;
      $a =~ s/(^-|-$)/$WChar/gi;
      $a =~ s/(^\?|\?$)/(.)/gi;
      $a =~ s/\)\(//gi;
      #print STDERR "$a $b\n";
      $line =~ s/$a/$1$b$2/gi;
      

      #print STDERR "$line\n";
    }

    #trocas de mais duma palavra (contraces prep+art e outros...)
    $line =~ s/ con  a(s?) /coa$1 /gi;
    $line =~ s/ con  o(s?) /co$1 /gi;
    $line =~ s/ con  unha(s?) /cunha$1 /gi;
    $line =~ s/ con  un(s?) /cun$1 /gi;
    $line =~ s/ de  unha(s?) /dunha$1 /gi;
    $line =~ s/ de  un(s?) /dun$1 /gi;
    $line =~ s/ en  unha(s?) /nunha$1 /gi;
    $line =~ s/ en  un(s?) /nun$1 /gi;
    #$line =~ s/(v(o)u|v(as)|v(a)i|v(amos)|v(ades)|v(an))  embora/march$2$3$4$5$6$7/gi;


    #trocas de grafias especiais
    $line =~ y/jJ/zaoxZAOX/;
         #print STDERR "temp: $line\n";
  
  #troca os futuros com pronomes proclticos: dar-lhes-emos por daremoslhes.
    
     $line =~  s/-(l[oa]s?)-([$w]+)/a-$1-$2/i ;
     $line =~  s/-(l[oa]s?)-([$w]+)/e-$1-$2/i ;
     $line =~  s/-(l[oa]s?)-([$w]+)/i-$1-$2/i ;     
     $line =~  s/-(l[oa]s?)-([$w]+)/o-$1-$2/i ;
     $line =~  s/-(l[oa]s?)-([$w]+)/u-$1-$2/i ;
     #print STDERR "inter: temp: $line\n";

     $line =~  s/-l([oa]s?)-eis/rdel-$1/gi;  
     $line =~  s/-l([oa]s?)-eis/ridel-$1/gi;  
     $line =~  s/-(l[oa]s?)-(s|emos|ias|amos)/r$2-$1/gi;
     $line =~  s/-l([oa]s?)-(ei|n||ian?)/r$2-$1/gi;   
     
     $line =~  s/s-l([oa]s?)/-l$1/gi;
      
     $line =~  s/-([$w]+)-eis/rdel-$1/gi;  
     $line =~  s/-([$w]+)-eis/ridel-$1/gi;  
     $line =~  s/-([$w]+)-(s|emos|ias|amos)/$2-$1/gi;
     $line =~  s/-([$w]+)-(ei|n||emos|ian?)/$2-$1/gi;

	 #print STDERR "temp: $line\n";
    #tira os guioes: 
    # $line =~ s/(?<=\w)-(?=\w{0,4}$NaoChar)/a/gi;
   # $line =~ s/(?<=\w)-(?=\w{0,4}$NaoChar)//gi;

    $line =~ s/  / /g;
    $line =~ s/^ //g;
    $line =~ s/ $//g;
    #print STDERR "$line\n" ;

    #regras de acentuao:
    my @listPals;
    my $p;
    (@listPals) = split (" ", $line);
    $line="";

    foreach $p (@listPals) {

       ##comia, tio, ...
       if ( ($p !~ /$vogalacentuada/) && 
           ( ($p =~ /$cons(i[aoe])([ns]?)($symbol?)$/i) ||
             ($p =~ /[qg](ui[aoe])([ns]?)($symbol?)$/i) ) )   {

           $p =~ s/i([aoe])([ns]?)($symbol?)$/$1$2$3/i;

      }
       ##sua, possuo, crua, ...
       elsif (($p !~ /$vogalacentuada/) && 
           ($p =~ /$cons(u[aoe])([ns]?)($symbol?)$/i) ) {

           $p =~ s/u([aoe])([ns]?)($symbol?)$/$1$2$3/i

      }

       ## aqui/latim/tabu, ...
       elsif (($p !~ /$vogalacentuada/) && 
           (length($p) >= 4) && 
           ($p !~ /(tui|$decrecente)(s?)($symbol?)$/i) &&
           ($p !~ /^($GR)[aeiou]([nmsx]?)(s?)($symbol?)$/i) ) {

           $p =~ s/i([nmsx]?)($symbol?)$/$1$2/i;
           $p =~ s/u([nmsx]?)($symbol?)$/$1$2/i;
           

      }
       
       ##txi/jri/bnus
       elsif (($p =~ /$vogalacentuada/) && 
           (length($p) >= 4) && 
           ($p =~ /$cons(i|u)(s?)($symbol?)$/i) ) {
          
	   
           $p =~ y//aeiou/;
       }


        ##/tnue/rgua (ditongo crecente...)
       elsif ( ($p =~ /$vogalacentuada/) && 
               ( ($p =~ /$cons($crecente)([sn]?)($symbol?)$/i) ||
                 ($p =~ /[qg]ui[ao]([sn]?)($symbol?)$/i) ) ) {

            $p =~ y//aeiou/;

      }

        ##/espanhis/caracis
      elsif ($p =~ /is($symbol?)$/i) {
          
           $p =~ s/is($symbol?)$/ois$1/i;
           

      } 

        ##/sair/constituir
      if (($p !~ /$vogalacentuada/) 
           && ($p =~ /$cons(ui|ai|ei)([rln])($symbol?)$/i)  ) {
          
           $p =~ s/i([rln])($symbol?)$/$1$2/i;
           $p =~ s/u([rln])($symbol?)$/$1$2/i;
	   

      }

     


       my $des="";
       my $raiz="";
       my $v="";
       my $first="";
       my $last="";

 ##pronomes compostos: no-las, se-me
       if (($p =~ /[$w]+\-[$w]+\-[$w]+/i) && ($p !~ /[0-9]+\-[0-9]+\-[0-9]+/i) ) {
	   ($raiz, $des) = ($p =~ /([$w]+)-([^ ]+)/i);
           #print STDERR "$raiz - $des\n";
           if ( ($raiz ne "") && ($des ne "")) {	    

               if (pertence ($des, $pronComposto)) {
                 $des =~ s/-//i;
                 $p = $raiz . "-" . $des;
	       } 
            }  
       }
       elsif (pertence ($p, $pronComposto )) {
             $p  =~ s/-//;
       }


        ## acentos de verbos com pronomes: chamo-me > chmome
       if (($p =~ /[$w]+\-[$w]+$/i) && ($p !~ /[0-9]+\-[0-9]+/i) && ($p !~ /[$w]+\-[$w]+\-[$w]+/i)) {
	   ($raiz, $des) = ($p =~ /([$w]+)-([$w]+)/i);
           #print STDERR "$raiz - $des\n";

          ##comiches + o/os
          if ( ($raiz =~ /s$/) && ($des =~ /^[ao]/)) {
              ($raiz =~ s/s$//); 
              ($des =~ s/([oa]s?)/l$1/);
           } 
           #print STDERR "2: $raiz - $des\n";
           if ( ($raiz ne "") && ($des ne "")) {
              ($des =~ s/llos/llelo/i); 
              ($des =~ s/llas/llela/i); 



             if (pertence ($des ,$pron)) {


              if ( ($raiz !~ /$vogalacentuada/) && ($raiz =~ /[$w]*[$consAll][$vogal][$consAll]+[$vogal]([ns]?)$/i) ) {     
                   #print STDERR "OKKK\n";   
                   ($first, $v, $last) = ($raiz =~ /([$w]*)([$vogal])([$consAll]+[$vogal]([ns]?))$/i);

                   if ($v ne "") {
		       $v = PorAcento($v);
                       $p = $first . $v .  $last . $des;
                       #print STDERR "regra1: $v - $raiz\n";
                    }
               }
              elsif ( ($raiz !~ /$vogalacentuada/) && ($raiz =~ /([$w]*)${decrecente}[$w]*[$vogal]([ns]?)$/i) ) {     
                   #print STDERR "OKKK\n";   
                   ($first, $v, $last) = ($raiz =~ /([$w]*)([$vogal])([$vogal][$w]*[$vogal]([ns]?))$/i);

                   if ($v ne "") {
		       $v = PorAcento($v);
                       $p = $first . $v .  $last . $des;
                       #print STDERR "regra1: $v - $raiz\n";
                    }
               }
              elsif ( ($raiz !~ /$vogalacentuada/) && ($raiz =~ /([^ ]+)[qg]u[$vogal]$/i) ) {        
                   ($first, $v, $last) = ($raiz =~ /([^ ]*)([$vogal])(([$consAll]?)[qg]u[$vogal])$/i);

                   if ($v ne "") {
		       $v = PorAcento($v);
                       $p = $first . $v .  $last . $des;
                       #print STDERR "regra1b: $v\n";
                    }
               }

              elsif ( ($raiz !~ /$vogalacentuada/) && ($raiz =~ /[$vogal][$vogal]$/i) &&
                      ($raiz !~ /$decrecente$/) && ($raiz !~ /oio|aio$/) &&
                       ($raiz !~ /[qg]u[$vogal]$/i) )  {        
                     ($first, $v, $last) = ($raiz =~ /([^ ]*)([$vogal])([$vogal])$/i);

                   if ($v ne "") {
		       $v = PorAcento($v);
                       $p = $first . $v .  $last . $des;
                       #print STDERR "regra1b: $v\n";
                    }
               }



	      elsif  ( ($raiz =~ /$vogalacentuada([ns]?)$/) && ($raiz !~ /^|^d([ns]?)$/i) ) {
                   ($first, $v, $last) = ($raiz =~ /([$w]*)($vogalacentuada)([ns]?)$/i);
                   if ($v ne "")  {
		       $v = TirarAcento($v);
                       $p = $first . $v . $last . $des;
                       #print STDERR "$first  $v  $last\n";
                    }
	     }
             elsif ($raiz =~ /$vogalacentuada/) {
                      $p = $raiz . $des;
                      #print STDERR "regra3\n";
	     
             }
             ##raiz acaba em ditongo crecente : por acento na primeira vogal
	     elsif ( ($raiz =~ /$crecente[ns]?$/) && ($raiz !~ /que$|gue$/i) &&
                     ($raiz !~ /oio|aio$/) ) {
                ($raiz =~ s/([$w]+)i([aeo][ns]?$)/$1$2/i);
                ($raiz =~ s/([$w]+)u([aeo][ns]?$)/$1$2/i);
                 $p = $raiz . $des;
                 #print STDERR "regra IA\n";
	    }
            elsif ( ($raiz =~ /$decrecente$/) &&  ($des =~ /^[oa]/i) ){
                      $p = $raiz . "n" . $des;
                      #print STDERR "regra3\n";
	     
             }
            
            else {
		  $p = $raiz . $des;
		 # print STDERR "$p..\n";
	      }
           }
	}
       }



    ## corrigir acentos verbos:

      $p =~ s/(bamos|bades|bamol|badel)/a$1/;
      $p =~ s/(ramos|rades|ramol|radel)/a$1/;
      $p =~ s/(semos|sedes|semol|sedel)/a$1/;
      $p =~ s/(amos|ades|amol|adel)/i$1/;
      $p =~ s/(semos|sedes|semol|sedel)/e$1/;
      $p =~ s/(ramos|rades|ramol|radel)/e$1/;
      $p =~ s/(ramos|rades|ramol|radel)/i$1/;
      $p =~ s/(semos|sedes|semol|sedel)/i$1/;
      $p =~ s/(amos|ades|amol|adel)/u$1/;
      $p =~ s/(amos|ades|amol|adel)/i$1/;
      $p =~ s/(semos|sedes|semol|sedel)/o$1/;
      
  
     ## Metacorreces:

      $p =~ s/^([cC])ontrache/$1ontraste/i;
      $p =~ s/^([nNdDlL])iches$/$1este/i;
      $p =~ s/^([eE])xiches$/$1xiste/i;
      $p =~ s/^([lL])inx/$1inux/i;
      $p =~ s/^([xX])aba/Java/i;
      $p =~ s/^([mM])al/$1ail/i;
      $p =~ s/^([cC])orps/$1orpus/i;
      $p =~ s/^([pP])lug-n/$1lug-in/i;
      $p =~ s/^([fF])uncton/$1unction/i;
      $p =~ s/^([aA])rraches/$1rrastre/i;
   ##rentroduzir
      $p =~ s/^([Rr])en/$1ein/i;
      $p =~ s/^([qQ])ueiron/$1ueiran/i;
      $p =~ s/^([fF])iron/$1iran/i;
      $p =~ s/^([sS])orrn/$1orr/i;


   ## problemas sintaticos : eu quixo ; son paulo....

    ### so para textos de INFO. 
      #$p =~ s/^clique/prema/;
      #$p =~ s/^Clique/Prema/;
      #$p =~ s/^([cC])lula(s?)/$1ela$2/;

      $line .= $p . " ";
    }

my $SpecialChar = "\?\!\\\%\&\/\(\)\\\+\*\'\=\.\,\;\:";
    
    $line =~ s/ \. /\. /g;
    $line =~ s/ \; /\; /g;
    $line =~ s/ \, /\, /g;
    $line =~ s/ \? /\? /g;
    $line =~ s/ \! /\! /g;
    $line =~ s/\[ /\[/g;
    $line =~ s/ \] /\] /g;
    $line =~ s/\( /\(/g;
    $line =~ s/ \) /\) /g;
           
    #$line =~ s/\" ([$w]+[$SpecialChar]*) \"/\"$1\"/g;
   # $line =~ s/ ([\]\)\"])($SpecialChar)/$1$2/g;
   
    $line =~ s/\" ([\w ]+) \"/\"$1\"/g;
 #colocar esta na web: 
 #$line =~ s/\" ([$w ]+) \"/\"$1\"/g;
    $line =~ s/ ([\]\)\"])([\W])/$1$2/g;


    
    print "$line\n";
}


sub PorAcento {
    my $result;
    my $x;

    ($x) = $_[0];
    
    
    if ($x eq "a") {$result = ""};
    if ($x eq "e") {$result = ""};
    if ($x eq "i") {$result = ""};
    if ($x eq "o") {$result = ""};
    if ($x eq "u") {$result = ""};
    if ($x eq "A") {$result = ""};
    if ($x eq "E") {$result = ""};
    if ($x eq "I") {$result = ""};
    if ($x eq "O") {$result = ""};
    if ($x eq "U") {$result = ""};
    return $result;

}

sub TirarAcento {
    my $result;
    my $x;

    ($x) = $_[0];
    
    
    if ($x eq "") {$result = "a"};
    if ($x eq "") {$result = "e"};
    if ($x eq "") {$result = "i"};
    if ($x eq "") {$result = "o"};
    if ($x eq "") {$result = "u"};
    if ($x eq "") {$result = "A"};
    if ($x eq "") {$result = "E"};
    if ($x eq "") {$result = "I"};
    if ($x eq "") {$result = "O"};
    if ($x eq "") {$result = "U"};
    return $result;

}


sub pertence {
    my $subcadeia;
    my $cadeia;
    my $temp;

    ($subcadeia) = $_[0];
    ($cadeia) = $_[1];

    $temp = "|" . $subcadeia . "|";
    if (index ($cadeia, $temp) ==-1) {
        return 0;
    }
    else {
        return 1;
    }
}








